#!/usr/bin/perl -w

use Tk;
use Tk::FileDialog;
use strict;

# method for loading the ndiswrapper
sub load_ndiswrapper{
  my $path = shift;

  # does our .inf-file exist?
  if( -e $path )
    {
      system("/usr/sbin/ndiswrapper -i $path");
      my $return_ndis = $? >> 8;
      print "return1:", $return_ndis,"\n";
      if( $return_ndis == 255 )
        {
          return 1;
        }
      else
        {
          system("/sbin/modprobe ndiswrapper");
          my $return_modprobe = $? >> 8;
          print "return2:", $return_modprobe,"\n";
          if( $return_modprobe == 255 )
            {
              return 1;
            }
        }
    }
  else
    {
      return 1;
    }
  return 0;
}


# at first we show the usual disclaimer that the usage of this
# script could simply destroy everything

my $disclaimer = MainWindow->new;
$disclaimer->withdraw;
$disclaimer->Label(-text => 'This is the configuration tool for the ndiswrapper utilities.
Be aware loading a windows driver file for your wlan 
card using this tool could freeze your system.

You need matching driver.inf and driver.sys files residing on
a mounted data medium. After the windows drivers have been 
successfully loaded via the ndiswrapper, you have to configure
your wlan settings via iwconfig. Future releases of this script
will include this.

Do you want to continue? ')->pack;
$disclaimer->Button(-text => 'Yes, continue!',
              -command => [$disclaimer => 'destroy']
             )->pack( -expand => 1,
               -fill => 'x');
$disclaimer->Button(-text => 'No, please abort.',
              -command => sub {
               exit;
              })->pack( -expand => 1,
               -fill => 'x');
$disclaimer->Label(-text => '<oehler@knopper.net>')->pack; 
$disclaimer->Popup;
MainLoop;


my $main = MainWindow->new;
$main->withdraw;
my $fname;

my $LoadDialog = $main->FileDialog(-Title =>'Knoppix config for ndiswrapper',
                                   -Create => 0);

$LoadDialog->configure(-FPat => '*inf',
                       -ShowAll => 'NO');

$main->Button(-text => 'Select *.inf file for WLAN card',
              -command => sub {
                $fname = $LoadDialog->Show(-Horiz => '1');
              })->pack(-expand => 1,
                       -fill => 'x');

$main->Button(-text => 'Ok',
              -command => sub{ 
                $main->destroy;
              })->pack(-expand => 1,
                       -fill => 'x');

$main->Button(-text => 'Exit',
              -command => sub {
                exit;
              })->pack(-expand => 1,
                       -fill => 'x');
$main->Popup;
MainLoop;

my $result_window = MainWindow->new;
$result_window->geometry("400x80");
$result_window->withdraw;

my $result = load_ndiswrapper( $fname );
if( $result == 0 )
  {
    $result_window->Label(-text => "Everything ok. You need to configure your wlan
card with iwconfig now.")->pack;
    $result_window->Button(-text => 'Ok',
                           -command => [$result_window => 'destroy']
                          )->pack( -expand => 1,
                                   -fill => 'x');
    $result_window->Popup;
    MainLoop;
  }
else
  {
    $result_window->Label(-text => "Either the ndiswrapper wasn't able to load
your .inf-file or the ndiswrapper module couldn't be loaded.")->pack;
    $result_window->Button(-text => 'Ok',
                           -command => [$result_window => 'destroy']
                          )->pack( -expand => 1,
                                   -fill => 'x');
    $result_window->Popup;
    MainLoop;
  }

exit;
